﻿use Anime;
--Crear tabla Anime
create table Anime(
id_anime int not null identity,
Nombre_Anime varchar(300) not null,
Temporada numeric(2),
Cantidad_de_Capitulos numeric(4),
Categorias varchar(300),
Estado varchar(100),
Fecha_Emision date,
Fecha_Termino date,
check (Temporada>=0),
check (Cantidad_de_Capitulos>=0),
unique(Nombre_Anime),
check ((Estado = 'Activo') or (Estado = 'Terminado') or (Estado = 'Pausado')),
constraint PK_anime primary key (id_anime)
);

--Crear tabla Autor
create table Autor(
id_creador int not null identity,
id_anime int,
Autor varchar(200),
Genero varchar(1),
Ano_Nacimiento date,
Ano_Fallecimiento date,
constraint PK_creador primary key (id_creador),
constraint FK_creador_anime foreign key (id_anime) references Anime(id_anime),
check ((Genero ='F') or (Genero = 'M'))
);

--Crear tabla Animes_Vistos
create table Animes_Vistos(
id_animes_vistos int not null identity,
id_anime int,
id_creador int,
Anime varchar(200),
Estado varchar(200),
constraint PK_animes_vistos primary key (id_animes_vistos),
constraint FK_animes_vistos_anime foreign key (id_anime) references Anime(id_anime),
constraint FK_animes_vistos_creador foreign key (id_creador) references Autor(id_creador),
check ((Estado = 'Terminado') or (Estado = 'Sin Terminar'))
);


select * from anime;

--insertar datos a table Anime
insert into anime values('One Piece', 1, 1122, 'Acción, Aventuras, Comedia, Drama, Fantasía, Shounen, Superpoderes', 'Pausado', '1997-07-22', '2024-10-24')
insert into anime values('Naruto', 1, 220, 'Acción, Artes Marciales, Comedia, Shounen, Superpoderes', 'Terminado', '1999-09-21', '2014-11-10')
insert into anime values('Naruto Shippuden', 1, 500, 'Acción, Artes Marciales, Comedia, Shounen, Superpoderes', 'Terminado', '2007-02-15', '2017-03-23')
insert into anime values('Dragon Ball Z', 1, 291, 'Acción, Artes Marciales, Shounen, Superpoderes', 'Terminado', '1989-04-26', '1996-01-31')
insert into anime values('Dragon Ball', 1, 153, 'Acción, Artes Marciales, Shounen, Superpoderes', 'Terminado', '1986-02-26', '1989-04-19')
insert into anime values('Dragon Ball GT', 1, 64, 'Acción, Artes Marciales, Shounen, Superpoderes', 'Terminado', '1996-02-07', '1997-11-19')
insert into anime values('Dragon Ball Super', 1, 131, 'Acción, Artes Marciales, Shounen, Superpoderes', 'Terminado', '2015-07-05', '2018-03-25')
insert into anime values('Katekyō Hitman Reborn!', 1, 203, 'Acción, comedia, drama, sobrenatural', 'Terminado', '2006-10-07', '2010-09-25')
insert into anime values('Dragon Ball Daima', 1,null , 'Acción, aventura, comedia, artes marciales, fantasía', 'Activo', '2024-10-11', null)
insert into anime values('Death Note', 1,37, 'Misterio, sobrenatural, thriller1', 'Terminado', '2003-12-01', '2006-05-15')
insert into anime values('Ranma ½', 1,161, 'Acción, Comedia romántica, Aventura', 'Terminado', '1987-08-19', '1996-03-06')
insert into anime values('Ranma ½ Remake', 1,null, 'Acción, Comedia romántica, Aventura', 'Terminado', '2024-10-06', null)


select * from Animes_Vistos;
select * from Anime;

--insertar datos a table Animes_Vistos
insert into Animes_Vistos values(null, null, 'One Piece','Terminado')
insert into Animes_Vistos values(null, null, 'Naruto','Terminado')
insert into Animes_Vistos values(null, null, 'Naruto Shippuden','Terminado')
insert into Animes_Vistos values(null, null, 'Dragon Ball Z','Terminado')
insert into Animes_Vistos values(null, null, 'Dragon Ball','Terminado')
insert into Animes_Vistos values(null, null, 'Dragon Ball GT','Terminado')
insert into Animes_Vistos values(null, null, 'Dragon Ball Super','Terminado')
insert into Animes_Vistos values(null, null, 'Katekyō Hitman Reborn!','Terminado')
insert into Animes_Vistos values(null, null, 'Dragon Ball Daima','Sin Terminar')
insert into Animes_Vistos values(null, null, 'Death Note','Terminado')
insert into Animes_Vistos values(null, null, 'Ranma ½','Terminado')
insert into Animes_Vistos values(null, null, 'Ranma ½ Remake','Sin Terminar')


select * from Anime;
select * from Autor;
select * from Animes_Vistos;
use Anime;

--insertar datos a tabla Autor
insert into Autor values(null, 'Akira Toriyama', 'M', '1955-04-05', '2024-03-01')
insert into Autor values(null, 'Eiichirō Oda', 'M', '1975-01-01', null)
insert into Autor values(null, 'Masashi Kishimoto', 'M', '1974-11-08', null)
insert into Autor values(null, 'Takeshi Obata', 'M', '1969-02-11', null)
insert into Autor values(null, 'Rumiko Takahashi', 'F', '1957-10-10', null, 'Ranma ½')
insert into Autor values(null, 'Akira Toriyama', 'M', '1955-04-05', '2024-03-01', 'Dragon Ball Super')
insert into Autor values(null, 'Akira Amano', 'F', '1973-06-22', null, 'Katekyo Hitman Reborn!')
insert into Autor values(null, 'Akira Toriyama', 'M', '1955-04-05', '2024-03-01', 'Dragon Ball Daima')
insert into Autor values(null, 'Akira Toriyama', 'M', '1955-04-05', '2024-03-01', 'Dragon Ball')
insert into Autor values(null, 'Akira Toriyama', 'M', '1955-04-05', '2024-03-01', 'Dragon Ball GT')
insert into Autor values(null, 'Masashi Kishimoto', 'M', '1974-11-08', null, 'Naruto Shippuden')
insert into Autor values(null, 'Rumiko Takahashi', 'F', '1957-10-10', null, 'Ranma ½ Remake')



--Me actualiza la columna id_anime de la tabla Autor
UPDATE Autor
SET id_anime = (
    SELECT id_anime
    FROM Anime
    WHERE Anime.Nombre_Anime = Autor.Anime
)
WHERE id_anime IS NULL;


--Me actualiza la columna id_creador de la tabla Animes_Vistos
update Animes_Vistos set id_creador = 
(select id_creador 
from Autor 
where Autor.Anime = Animes_Vistos.Anime)
where id_creador is null;